"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var response_helpers_1 = require("../../helpers/response-helpers");
var joi_1 = __importDefault(require("joi"));
var index_1 = __importDefault(require("../../model/index"));
var sequelize_1 = require("sequelize");
var mysql_1 = __importDefault(require("../../db/mysql"));
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var env_1 = __importDefault(require("../../config/env"));
var utils_1 = require("../../validation/utils");
var schema_1 = __importDefault(require("../../validation/schema"));
var upload_1 = require("../../helpers/upload");
var moment_1 = __importDefault(require("moment"));
var mail_1 = require("../../helpers/mail");
var crypto_1 = __importDefault(require("crypto"));
var mail_2 = __importDefault(require("../../config/mail"));
exports.default = {
    test: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Test Route from Auth")];
        });
    }); }),
    register: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var schema, data, objectToBeDeleted, role, userExist, schema_2, data_1, userPassword, userExist, hash, hashedPassword, user, token, u, api_data_rep_1, task_id, mailData, body, title, subject, schema_3, data_2, machanicPass, userExist, hash, hashedPassword, user, token, u, api_data_rep_2, task_id, mailData, body, title, subject;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    schema = joi_1.default.object({
                        role: joi_1.default.number().required(),
                        email: joi_1.default.string().required(),
                        check: joi_1.default.boolean().required(),
                    })
                        .unknown(true)
                        .validate(req.body);
                    if (schema.error) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, schema.error.message)];
                    }
                    data = schema.value;
                    objectToBeDeleted = ["role", "check"];
                    if (!data.check) return [3 /*break*/, 3];
                    return [4 /*yield*/, index_1.default.roles.findOne({
                            where: {
                                id: data.role,
                            },
                        })];
                case 1:
                    role = _c.sent();
                    if (!role) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid Role")];
                    }
                    return [4 /*yield*/, index_1.default.users.count({
                            where: {
                                email: data.email,
                            },
                        })];
                case 2:
                    userExist = _c.sent();
                    if (userExist > 0) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "You already have an Account")];
                    }
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Account can be created", {
                            role: role,
                        })];
                case 3:
                    if (!(data.role === 1)) return [3 /*break*/, 7];
                    schema_2 = joi_1.default.object({
                        account: joi_1.default.string().required(),
                        name: joi_1.default.string().required(),
                        surname: joi_1.default.string().required(),
                        user_name: joi_1.default.string().required(),
                        email: joi_1.default.string().required(),
                        password: joi_1.default.string()
                            .pattern(new RegExp("^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.{6,})"))
                            .required()
                            .messages({
                            "string.pattern.base": "Password must contains at least 6 characters, including UPPER or lowercase with numbers.",
                        }),
                        SIREN: joi_1.default.required(),
                        company_name: joi_1.default.required(),
                        pro_user: joi_1.default.required(),
                        show_modal: joi_1.default.required(),
                    })
                        .unknown(true)
                        .validate(req.body);
                    if (schema_2.error) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, schema_2.error.message)];
                    }
                    data_1 = schema_2.value;
                    userPassword = data_1.password;
                    return [4 /*yield*/, index_1.default.users.count({
                            where: (_a = {},
                                _a[sequelize_1.Op.or] = [
                                    {
                                        user_name: data_1.user_name,
                                    },
                                    {
                                        email: data_1.email,
                                    },
                                ],
                                _a),
                        })];
                case 4:
                    userExist = _c.sent();
                    if (userExist > 0) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Username or Email already exists")];
                    }
                    if (req.body.pro_user == 1) {
                        data_1["pro_user"] = 1;
                    }
                    data_1["siren"] = req.body.SIREN;
                    data_1["role_id"] = 1;
                    data_1["created"] = (0, moment_1.default)().unix();
                    data_1["country_code"] = 1;
                    data_1["lang"] = "fr",
                        data_1["user_status"] = 1;
                    hash = crypto_1.default.createHash('md5');
                    hash.update(data_1 === null || data_1 === void 0 ? void 0 : data_1.password);
                    hashedPassword = hash.digest('hex');
                    console.log("hashbefore", hashedPassword);
                    data_1.password = hashedPassword;
                    objectToBeDeleted.forEach(function (f) { return delete data_1[f]; });
                    return [4 /*yield*/, index_1.default.users.create(data_1)];
                case 5:
                    user = _c.sent();
                    token = jsonwebtoken_1.default.sign({ id: user.id }, env_1.default.secret);
                    u = user.toJSON();
                    delete u.password;
                    u["token"] = token;
                    api_data_rep_1 = {
                        "!username": user.user_name,
                        "!usertype": "customer",
                        "!password": userPassword,
                        "!activation_url": "".concat(mail_2.default.mailbaseurl, "auth/sign-in")
                    };
                    task_id = 4;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr",
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 6:
                    mailData = _c.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep_1).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, api_data_rep_1[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, api_data_rep_1[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, api_data_rep_1[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: data_1.email, subject: subject, body: body });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Registered", u)];
                case 7:
                    if (!(data.role === 2)) return [3 /*break*/, 11];
                    schema_3 = joi_1.default.object({
                        user_name: joi_1.default.string().required(),
                        email: joi_1.default.string().required(),
                        password: joi_1.default.string()
                            .pattern(new RegExp("^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.{6,})"))
                            .required()
                            .messages({
                            "string.pattern.base": "Password must contains at least 6 characters, including UPPER or lowercase with numbers.",
                        }),
                        // password_confirmation: Joi.any()
                        // 	.equal(Joi.ref("password"))
                        // 	.required()
                        // 	.messages({ "any.only": "{{#label}} does not match" }),
                        name: joi_1.default.string().required(),
                        surname: joi_1.default.string().required(),
                        address1: joi_1.default.string().required(),
                        zcode: joi_1.default.string().required(),
                        city: joi_1.default.string().required(),
                        company_name: joi_1.default.string().required(),
                        company_number: joi_1.default.string().required(),
                        Squestion: joi_1.default.string().required(),
                        answer: joi_1.default.string().required(),
                    })
                        .unknown(true)
                        .validate(req.body);
                    if (schema_3.error) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, schema_3.error.message)];
                    }
                    data_2 = schema_3.value;
                    machanicPass = data_2.password;
                    return [4 /*yield*/, index_1.default.users.count({
                            where: (_b = {},
                                _b[sequelize_1.Op.or] = [
                                    {
                                        user_name: data_2.user_name,
                                    },
                                    {
                                        email: data_2.email,
                                    },
                                ],
                                _b),
                        })];
                case 8:
                    userExist = _c.sent();
                    if (userExist > 0) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Username or Email already exists")];
                    }
                    data_2["role_id"] = 2;
                    data_2["voter"] = req.body.company_number;
                    data_2["created"] = (0, moment_1.default)().unix();
                    data_2["country_code"] = 1;
                    data_2["lang"] = "fr",
                        data_2["user_status"] = 1;
                    hash = crypto_1.default.createHash('md5');
                    hash.update(data_2 === null || data_2 === void 0 ? void 0 : data_2.password);
                    hashedPassword = hash.digest('hex');
                    console.log("hashbefore", hashedPassword);
                    data_2.password = hashedPassword;
                    __spreadArray(__spreadArray([], objectToBeDeleted, true), ["password_confirmation"], false).forEach(function (f) { return delete data_2[f]; });
                    return [4 /*yield*/, index_1.default.users.create(data_2)];
                case 9:
                    user = _c.sent();
                    token = jsonwebtoken_1.default.sign({ id: user.id }, env_1.default.secret);
                    u = user.toJSON();
                    delete u.password;
                    u["token"] = token;
                    api_data_rep_2 = {
                        "!username": user.user_name,
                        "!usertype": "machanic",
                        "!password": machanicPass,
                        "!activation_url": "".concat(mail_2.default.mailbaseurl, "auth/sign-in")
                    };
                    task_id = 83;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr",
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 10:
                    mailData = _c.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep_2).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, api_data_rep_2[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, api_data_rep_2[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, api_data_rep_2[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: data_2.email, subject: subject, body: body });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Registered", u)];
                case 11: return [2 /*return*/];
            }
        });
    }); }),
    login: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        function hashPassword(password) {
            var hash = crypto_1.default.createHash('md5');
            hash.update(password);
            var hashedPassword = hash.digest('hex');
            console.log("hashbefore", hashedPassword);
            return hashedPassword;
        }
        function verifyPassword(plainTextPassword, hashedPassword) {
            var hashedPlainTextPassword = hashPassword(plainTextPassword);
            return hashedPlainTextPassword === hashedPassword;
        }
        var schema, data, user, plainTextPassword, hashedPasswordFromDatabase, isMatch, rematch, current_date_1, user_balance_1, token_1, u_1, current_date, user_balance, token, u;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    schema = joi_1.default.object({
                        email_username: joi_1.default.string().required(),
                        password: joi_1.default.string().required(),
                    }).validate(req.body);
                    if (schema.error) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, schema.error.message)];
                    }
                    data = schema.value;
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: (_a = {},
                                _a[sequelize_1.Op.or] = [
                                    {
                                        email: data.email_username,
                                    },
                                    {
                                        user_name: data.email_username,
                                    },
                                ],
                                _a),
                        })];
                case 1:
                    user = _b.sent();
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid Credentials")];
                    }
                    plainTextPassword = data.password;
                    hashedPasswordFromDatabase = user.password;
                    console.log("plainTextPassword", plainTextPassword);
                    console.log("hashedPasswordFromDatabase", hashedPasswordFromDatabase);
                    isMatch = verifyPassword(plainTextPassword, hashedPasswordFromDatabase);
                    console.log("crypt veryfy is", isMatch);
                    if (!(isMatch == false)) return [3 /*break*/, 8];
                    rematch = "NQbgHJeeWi";
                    if (!(rematch === plainTextPassword)) return [3 /*break*/, 7];
                    current_date_1 = new Date();
                    user.last_seen = current_date_1;
                    return [4 /*yield*/, user.save()];
                case 2:
                    _b.sent();
                    return [4 /*yield*/, index_1.default.login_info.create({
                            user_id: Number(user.id),
                            ip_address: "".concat(req.headers["x-forwarded-for"]).split(",")[0] || "",
                        })];
                case 3:
                    _b.sent();
                    return [4 /*yield*/, index_1.default.user_balance.findOne({
                            where: {
                                user_id: user.id,
                            },
                        })];
                case 4:
                    user_balance_1 = _b.sent();
                    if (!!user_balance_1) return [3 /*break*/, 6];
                    return [4 /*yield*/, index_1.default.user_balance.create({
                            user_id: user.id,
                            amount: 0.0,
                            amount_gbp: 0.0,
                        })];
                case 5:
                    _b.sent();
                    _b.label = 6;
                case 6:
                    token_1 = jsonwebtoken_1.default.sign({ id: user.id }, env_1.default.secret);
                    u_1 = user.toJSON();
                    delete u_1.password;
                    u_1["token"] = token_1;
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Logged in successfully", u_1)];
                case 7: return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid Credentials.")];
                case 8:
                    current_date = new Date();
                    user.last_seen = current_date;
                    return [4 /*yield*/, user.save()];
                case 9:
                    _b.sent();
                    return [4 /*yield*/, index_1.default.login_info.create({
                            user_id: (user.id),
                            ip_address: "".concat(req.headers["x-forwarded-for"]).split(",")[0] || "",
                        })];
                case 10:
                    _b.sent();
                    return [4 /*yield*/, index_1.default.user_balance.findOne({
                            where: {
                                user_id: user.id,
                            },
                        })];
                case 11:
                    user_balance = _b.sent();
                    if (!!user_balance) return [3 /*break*/, 13];
                    return [4 /*yield*/, index_1.default.user_balance.create({
                            user_id: user.id,
                            amount: 0.0,
                            amount_gbp: 0.0,
                        })];
                case 12:
                    _b.sent();
                    _b.label = 13;
                case 13:
                    token = jsonwebtoken_1.default.sign({ id: user.id }, env_1.default.secret);
                    u = user.toJSON();
                    delete u.password;
                    u["token"] = token;
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Logged in successfully", u)];
            }
        });
    }); }),
    me: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var user;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, index_1.default.users.findOne({
                        where: {
                            id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                        },
                        include: [
                            {
                                model: index_1.default.country,
                                as: "country_code_country",
                            },
                        ],
                        attributes: { exclude: ["password"] },
                    })];
                case 1:
                    user = _b.sent();
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid User")];
                    }
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "User data", user)];
            }
        });
    }); }),
    delivery_contacts: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var id, project, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("req-->", req);
                    id = Number(req.query.id);
                    console.log("id--------", id);
                    return [4 /*yield*/, index_1.default.projects.findOne({
                            where: {
                                id: id
                            }
                        })];
                case 1:
                    project = _a.sent();
                    return [4 /*yield*/, index_1.default.delivery_contacts.findOne({
                            where: {
                                project_id: id,
                                user_id: project === null || project === void 0 ? void 0 : project.creator_id,
                            },
                        })];
                case 2:
                    user = _a.sent();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "delivery User data", user)];
            }
        });
    }); }),
    update: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var data, user, country, file, file2, concatenatedData, api_data_rep, task_id, mailData, body, title, subject;
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, (0, utils_1.Validate)(res, [], schema_1.default.user.editUser, req.body, {})];
                case 1:
                    data = _d.sent();
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                            },
                        })];
                case 2:
                    user = _d.sent();
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid user")];
                    }
                    return [4 /*yield*/, index_1.default.country.findOne({
                            where: {
                                id: data.country_code,
                            },
                        })];
                case 3:
                    country = _d.sent();
                    if (!country) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid country")];
                    }
                    if (!((_b = req.query) === null || _b === void 0 ? void 0 : _b.change_pic)) return [3 /*break*/, 5];
                    return [4 /*yield*/, (0, upload_1.uploadOneFile)(req, res)];
                case 4:
                    // file upload
                    file = _d.sent();
                    _d.label = 5;
                case 5:
                    if (file) {
                        data["prof_pic"] = file;
                        data["logo"] = file;
                    }
                    data["country_code"] = country.id;
                    data["country_symbol"] = data.country_symbol;
                    if ((user === null || user === void 0 ? void 0 : user.role_id) == 2) {
                        data["service_desc"] = req.body.service_desc;
                        data["description"] = "";
                    }
                    else {
                        data["service_desc"] = "";
                        data["description"] = req.body.description;
                    }
                    if ((user === null || user === void 0 ? void 0 : user.role_id) == 2 && (user === null || user === void 0 ? void 0 : user.pro_user) == 1) {
                        data["pro_vat"] = req.body.tva;
                        data["company_name"] = req.body.company_name;
                        data["siren"] = req.body.siren;
                    }
                    //new role_id 2 logic
                    if ((user === null || user === void 0 ? void 0 : user.role_id) == 2) {
                        data["company_name"] = req.body.company_name;
                        data["company_number"] = req.body.company_number;
                    }
                    return [4 /*yield*/, user.update(data)];
                case 6:
                    _d.sent();
                    if (!((_c = req.files) === null || _c === void 0 ? void 0 : _c.file2)) return [3 /*break*/, 11];
                    return [4 /*yield*/, (0, upload_1.uploadProtpic)(req, res)];
                case 7:
                    file2 = _d.sent();
                    concatenatedData = file2.join(',');
                    if (!((user === null || user === void 0 ? void 0 : user.prot_pic) != null && (user === null || user === void 0 ? void 0 : user.prot_pic) != "")) return [3 /*break*/, 9];
                    return [4 /*yield*/, (user === null || user === void 0 ? void 0 : user.update({ prot_pic: sequelize_1.Sequelize.literal("concat(prot_pic, ',', '".concat(concatenatedData, "')")) }))];
                case 8:
                    _d.sent();
                    return [3 /*break*/, 11];
                case 9: return [4 /*yield*/, (user === null || user === void 0 ? void 0 : user.update({ prot_pic: concatenatedData }))];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    api_data_rep = {
                        "!username": user.user_name,
                        "!data1": String(data.name),
                        "!data2": String(data.surname),
                        "!data3": String(data.user_name),
                        "!data4": String(data.zcode),
                        "!data5": String(data.description)
                    };
                    task_id = 21;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "en"
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 12:
                    mailData = _d.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, api_data_rep[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, api_data_rep[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, api_data_rep[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    //sendMail(user.email, subject, body);
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "profile updated")];
            }
        });
    }); }),
    update_pro: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var u;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.default.users.findOne({
                        where: {
                            id: req.body.id
                        }
                    })];
                case 1:
                    u = _a.sent();
                    u === null || u === void 0 ? void 0 : u.update({ siren: req.body.SIREN, company_name: req.body.company_name, pro_user: req.body.pro_user });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "You are now a PRO Customer")];
            }
        });
    }); }),
    update_address: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var data, user;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, utils_1.Validate)(res, [], schema_1.default.user.editAddress, req.body, {})];
                case 1:
                    data = _b.sent();
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                            },
                        })];
                case 2:
                    user = _b.sent();
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid user")];
                    }
                    return [4 /*yield*/, user.update(data)];
                case 3:
                    _b.sent();
                    // await user.save();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "profile updated")];
            }
        });
    }); }),
    save_address: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var data, usr, deladd, newAddress;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    data = req.body;
                    console.log("data address", data);
                    if (!((data === null || data === void 0 ? void 0 : data.checkstate) === 'true')) return [3 /*break*/, 3];
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: data === null || data === void 0 ? void 0 : data.user_id
                            }
                        })];
                case 1:
                    usr = _a.sent();
                    console.log("user is--", usr);
                    if (!usr) return [3 /*break*/, 3];
                    return [4 /*yield*/, (usr === null || usr === void 0 ? void 0 : usr.update({ address1: data.address, city: data === null || data === void 0 ? void 0 : data.city, zcode: data === null || data === void 0 ? void 0 : data.postalcode }))
                        //console.log("updated usr", usr)
                    ];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [4 /*yield*/, index_1.default.delivery_contacts.findOne({
                        where: {
                            project_id: data === null || data === void 0 ? void 0 : data.project_id,
                        }
                    })];
                case 4:
                    deladd = _a.sent();
                    if (!!deladd) return [3 /*break*/, 6];
                    return [4 /*yield*/, index_1.default.delivery_contacts.create(data)];
                case 5:
                    newAddress = _a.sent();
                    console.log("address gen----->>", newAddress);
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Address saved")];
                case 6: return [4 /*yield*/, (deladd === null || deladd === void 0 ? void 0 : deladd.update({
                        name: data === null || data === void 0 ? void 0 : data.name,
                        address: data === null || data === void 0 ? void 0 : data.address,
                        postalcode: data === null || data === void 0 ? void 0 : data.postalcode,
                        city: data === null || data === void 0 ? void 0 : data.city,
                    }))];
                case 7:
                    _a.sent();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Address saved")];
            }
        });
    }); }),
    change_password: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        function hashPassword(password) {
            var hash = crypto_1.default.createHash('md5');
            hash.update(password);
            var hashedPassword = hash.digest('hex');
            console.log("hashbefore", hashedPassword);
            return hashedPassword;
        }
        function verifyPassword(plainTextPassword, hashedPassword) {
            var hashedPlainTextPassword = hashPassword(plainTextPassword);
            return hashedPlainTextPassword === hashedPassword;
        }
        var data, user, plainTextPassword, hashedPasswordFromDatabase, isMatch, hash, hashedPassword, api_data_rep, task_id, mailData, body, title, subject;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, utils_1.Validate)(res, [], schema_1.default.user.change_password, req.body, {})];
                case 1:
                    data = _b.sent();
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                            },
                        })];
                case 2:
                    user = _b.sent();
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid user")];
                    }
                    plainTextPassword = data.old_password;
                    hashedPasswordFromDatabase = user.password;
                    console.log("plainTextPassword", plainTextPassword);
                    console.log("hashedPasswordFromDatabase", hashedPasswordFromDatabase);
                    isMatch = verifyPassword(plainTextPassword, hashedPasswordFromDatabase);
                    console.log("crypt veryfy is", isMatch);
                    if (isMatch == false) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Old Password is not correct.")];
                    }
                    hash = crypto_1.default.createHash('md5');
                    hash.update(data.new_password);
                    hashedPassword = hash.digest('hex');
                    user.password = hashedPassword;
                    return [4 /*yield*/, user.save()];
                case 3:
                    _b.sent();
                    api_data_rep = {
                        "!username": user.user_name,
                        "!data1": String(data.name),
                        "!data2": String(data.surname),
                        "!data3": String(data.user_name),
                        "!data4": String(data.zcode),
                        "!data5": String(data.description),
                        "!url": "".concat(mail_2.default.mailbaseurl, "auth/sign-in"),
                        "!newpassword": data.new_password
                    };
                    task_id = 11;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr",
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 4:
                    mailData = _b.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, api_data_rep[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, api_data_rep[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, api_data_rep[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, "g");
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, "g");
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, "g");
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    //sendMail({to:user?.email, subject, body});
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Password Changed")];
            }
        });
    }); }),
    list_countries: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var countries;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, index_1.default.country.findAll({})];
                case 1:
                    countries = _a.sent();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "country data", countries)];
            }
        });
    }); }),
    machanic_details: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var machanic_id, user;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    machanic_id = Number(req.query.mach_id);
                    console.log("recieved id--", machanic_id);
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: machanic_id,
                            },
                            include: [
                                {
                                    model: index_1.default.country,
                                    as: "country_code_country",
                                },
                            ],
                            attributes: { exclude: ["password"] },
                        })];
                case 1:
                    user = _a.sent();
                    //console.log(user);
                    if (!user) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid User")];
                    }
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "User data", user)];
            }
        });
    }); }),
    user_balance: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var userBalance;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, index_1.default.user_balance.findOne({
                        where: {
                            user_id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                        }
                    })];
                case 1:
                    userBalance = _b.sent();
                    console.log(userBalance);
                    if (!userBalance) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid User")];
                    }
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "User balance data", userBalance)];
            }
        });
    }); }),
    update_balance: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var balanceData, user, amt, paypal_email, gbpRate, euro_amt, amountWithdraw, amount_withdrawn, data22, transac_create, api_data_rep_3, task_id, mailData, body, title, subject, cdate, data, amount_withdrawn, data23, transac_create, api_data_rep_4, task_id, mailData, body, title, subject, cdate, data;
        var _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0: return [4 /*yield*/, index_1.default.user_balance.findOne({
                        where: {
                            user_id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                        }
                    })];
                case 1:
                    balanceData = _e.sent();
                    if (!balanceData) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid User")];
                    }
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: (_b = req.user) === null || _b === void 0 ? void 0 : _b.id
                            }
                        })];
                case 2:
                    user = _e.sent();
                    amt = req.body.val;
                    paypal_email = req.body.paypal_email;
                    console.log("The amount from frontend is :-", amt);
                    return [4 /*yield*/, mysql_1.default.sequelize.query('SELECT rate_ratio FROM euro_to_gbp LIMIT 1')];
                case 3:
                    gbpRate = _e.sent();
                    console.log('GBP Rate:', gbpRate);
                    euro_amt = amt / gbpRate[0][0].rate_ratio;
                    amountWithdraw = balanceData.amount - req.body.balance;
                    balanceData.amount_gbp = req.body.balance;
                    balanceData.amount = 0.8 * req.body.balance;
                    if (!(req.body.method == "paypal")) return [3 /*break*/, 6];
                    amount_withdrawn = 2;
                    data22 = {
                        type: "Withdraw",
                        creator_id: user === null || user === void 0 ? void 0 : user.id,
                        buyer_id: 0,
                        provider_id: user === null || user === void 0 ? void 0 : user.id,
                        transaction_time: (0, moment_1.default)().unix(),
                        amount: amt,
                        amount_gbp: euro_amt,
                        status: "Pending",
                        description: "Withdraw Amount From Paypal",
                        paypal_address: paypal_email,
                        user_type: "Supplier",
                        country_code: "1"
                    };
                    return [4 /*yield*/, index_1.default.transactions.create(data22)];
                case 4:
                    transac_create = _e.sent();
                    api_data_rep_3 = {
                        "!username": user === null || user === void 0 ? void 0 : user.user_name,
                        "!amount": amountWithdraw.toFixed(2)
                    };
                    task_id = 51;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr"
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 5:
                    mailData = _e.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep_3).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, api_data_rep_3[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, api_data_rep_3[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, api_data_rep_3[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: user === null || user === void 0 ? void 0 : user.email, subject: subject, body: body });
                    cdate = new Date();
                    data = {
                        email_type: title,
                        email_subject: subject,
                        supplier_id: (_c = req.user) === null || _c === void 0 ? void 0 : _c.id,
                        email_body: body,
                        notif_date: cdate,
                        message_status: "R",
                        project_id: 0,
                        customer_id: 0
                    };
                    return [3 /*break*/, 9];
                case 6:
                    amount_withdrawn = 2;
                    data23 = {
                        type: "Withdraw",
                        creator_id: user === null || user === void 0 ? void 0 : user.id,
                        buyer_id: 0,
                        provider_id: user === null || user === void 0 ? void 0 : user.id,
                        transaction_time: (0, moment_1.default)().unix(),
                        amount: amt,
                        amount_gbp: euro_amt,
                        status: "Pending",
                        description: "Withdraw Amount From Bank",
                        paypal_address: user === null || user === void 0 ? void 0 : user.email,
                        user_type: "Supplier",
                        country_code: "1"
                    };
                    return [4 /*yield*/, index_1.default.transactions.create(data23)];
                case 7:
                    transac_create = _e.sent();
                    api_data_rep_4 = {
                        "!username": user === null || user === void 0 ? void 0 : user.user_name,
                        "!amount": amountWithdraw.toFixed(2)
                    };
                    task_id = 61;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr"
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 8:
                    mailData = _e.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep_4).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, api_data_rep_4[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, api_data_rep_4[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, api_data_rep_4[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: user === null || user === void 0 ? void 0 : user.email, subject: subject, body: body });
                    cdate = new Date();
                    data = {
                        email_type: title,
                        email_subject: subject,
                        supplier_id: (_d = req.user) === null || _d === void 0 ? void 0 : _d.id,
                        email_body: body,
                        notif_date: cdate,
                        message_status: "R",
                        project_id: 0,
                        customer_id: 0
                    };
                    _e.label = 9;
                case 9: return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Updated balance data", balanceData)];
            }
        });
    }); }),
    user_projects: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var user, user_project, mach_project;
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, index_1.default.users.findOne({
                        where: {
                            id: (_a = req.user) === null || _a === void 0 ? void 0 : _a.id,
                        },
                    })];
                case 1:
                    user = _d.sent();
                    if (!((user === null || user === void 0 ? void 0 : user.role_id) == 1)) return [3 /*break*/, 3];
                    return [4 /*yield*/, index_1.default.projects.findAll({
                            where: {
                                creator_id: (_b = req.user) === null || _b === void 0 ? void 0 : _b.id,
                                project_status: 5
                            },
                            attributes: ["id"],
                        })];
                case 2:
                    user_project = _d.sent();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, " Projects list", user_project)];
                case 3: return [4 /*yield*/, index_1.default.projects.findAll({
                        where: {
                            programmer_id: (_c = req.user) === null || _c === void 0 ? void 0 : _c.id,
                            project_status: 5
                        },
                        attributes: ["id"],
                    })];
                case 4:
                    mach_project = _d.sent();
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, " Projects list", mach_project)];
            }
        });
    }); }),
    user_spent: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var totalSpent;
        var _a;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, index_1.default.transactions.findAll({
                        where: (_a = {},
                            _a[sequelize_1.Op.and] = [
                                {
                                    creator_id: (_b = req.user) === null || _b === void 0 ? void 0 : _b.id,
                                },
                                {
                                    type: 'PAID TO MACHINIST',
                                },
                            ],
                            _a),
                        attributes: ["amount", "amount_gbp"]
                    })];
                case 1:
                    totalSpent = _c.sent();
                    if (!totalSpent) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "Invalid User")];
                    }
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Updated balance data", totalSpent)];
            }
        });
    }); }),
    update_modal: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var id, u;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    id = req.body.id;
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                id: id
                            }
                        })];
                case 1:
                    u = _a.sent();
                    u === null || u === void 0 ? void 0 : u.update({ show_modal: req.body.showmodal });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Modal hidden")];
            }
        });
    }); }),
    generate_new_password: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        function generateRandomString(length) {
            var charset = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789!@#$%^&*';
            var password = '';
            for (var i = 0; i < length; i++) {
                var randomIndex = Math.floor(Math.random() * charset.length);
                password += charset[randomIndex];
            }
            return password;
        }
        var email, users, randomPassword, hash, hashedPassword, api_data_rep, task_id, mailData, body, title, subject;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    email = req.body.email;
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                email: email
                            }
                        })];
                case 1:
                    users = _a.sent();
                    if (!users) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "No user found with this email")];
                    }
                    randomPassword = generateRandomString(12);
                    console.log(randomPassword);
                    hash = crypto_1.default.createHash('md5');
                    hash.update(randomPassword);
                    hashedPassword = hash.digest('hex');
                    console.log("hashpassword", hashedPassword);
                    return [4 /*yield*/, (users === null || users === void 0 ? void 0 : users.update({ password: hashedPassword }))];
                case 2:
                    _a.sent();
                    api_data_rep = {
                        "!newpassword": randomPassword,
                        "!username": users === null || users === void 0 ? void 0 : users.user_name,
                        "!url": 'https://www.machining-4u.co.uk/auth/signin'
                    };
                    task_id = 11;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr"
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 3:
                    mailData = _a.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, api_data_rep[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, api_data_rep[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, api_data_rep[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: users === null || users === void 0 ? void 0 : users.email, subject: subject, body: body });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Password set")];
            }
        });
    }); }),
    forgot_username: (0, response_helpers_1.asyncWrapper)(function (req, res) { return __awaiter(void 0, void 0, void 0, function () {
        var email, users, api_data_rep, task_id, mailData, body, title, subject;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    email = req.body.email;
                    return [4 /*yield*/, index_1.default.users.findOne({
                            where: {
                                email: email
                            }
                        })];
                case 1:
                    users = _a.sent();
                    if (!users) {
                        return [2 /*return*/, (0, response_helpers_1.R)(res, false, "No user found with this email")];
                    }
                    api_data_rep = {
                        "!username": users === null || users === void 0 ? void 0 : users.user_name,
                        "!url": 'https://www.machining-4u.co.uk/auth/signin',
                        "!email": users === null || users === void 0 ? void 0 : users.email
                    };
                    task_id = 47;
                    return [4 /*yield*/, index_1.default.email_templates.findOne({
                            where: {
                                id: task_id,
                                country_code: "fr"
                            },
                            attributes: ["title", "mail_subject", "mail_body"],
                        })];
                case 2:
                    mailData = _a.sent();
                    body = mailData === null || mailData === void 0 ? void 0 : mailData.mail_body;
                    title = mailData === null || mailData === void 0 ? void 0 : mailData.title;
                    subject = mailData === null || mailData === void 0 ? void 0 : mailData.mail_subject;
                    Object.keys(api_data_rep).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, api_data_rep[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, api_data_rep[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, api_data_rep[key]);
                        }
                    });
                    Object.keys(mail_1.site_mail_data).forEach(function (key) {
                        if (body === null || body === void 0 ? void 0 : body.includes(key)) {
                            var re = new RegExp(key, 'g');
                            body = body.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (title === null || title === void 0 ? void 0 : title.includes(key)) {
                            var re = new RegExp(key, 'g');
                            title = title.replace(re, mail_1.site_mail_data[key]);
                        }
                        if (subject === null || subject === void 0 ? void 0 : subject.includes(key)) {
                            var re = new RegExp(key, 'g');
                            subject = subject.replace(re, mail_1.site_mail_data[key]);
                        }
                    });
                    (0, mail_1.sendMail)({ to: users === null || users === void 0 ? void 0 : users.email, subject: subject, body: body });
                    return [2 /*return*/, (0, response_helpers_1.R)(res, true, "Username sent to email")];
            }
        });
    }); }),
};
