"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var project_1 = __importDefault(require("../controller/project"));
var express_fileupload_1 = __importDefault(require("express-fileupload"));
var router = express_1.default.Router();
router.get("/test", project_1.default.test);
router.get("/list", project_1.default.list);
router.get("/get-spacer-projects", project_1.default.get_spacer_projects);
router.get("/project-gallery-new", project_1.default.project_gallery2);
router.get("/my", project_1.default.my);
router.get("/detail", project_1.default.show);
router.post("/ask-question", project_1.default.askQuestion);
router.post("/add-answer", project_1.default.addAnswer);
router.post("/get-temp", project_1.default.get_temp);
router.get("/get-my-temp", project_1.default.get_my_temp);
router.get("/select-machinist", project_1.default.select_machinist);
router.post("/deposit-fund", project_1.default.add_payment);
router.post("/review-machinist", project_1.default.review_machinist);
router.get("/list-msgs", project_1.default.list_msgs);
router.get("/list-bid-msgs", project_1.default.list_bid_msgs);
router.get("/my-inbox-msgs", project_1.default.my_msgs);
router.get("/all-reviews", project_1.default.allreviews);
router.get("/steps_completed_supplier", project_1.default.steps_completed_supplier);
router.get("/customer_releasepayment_checkbox", project_1.default.customer_releasepayment_checkbox);
router.get("/steps-text", project_1.default.steps_text);
/*FILE UPLOAD APIs */
router.use((0, express_fileupload_1.default)());
router.post("/add", project_1.default.add);
router.post("/invoice-list", project_1.default.invoice_machinist);
router.get("/invoice-list", project_1.default.invoice_machinist);
router.post("/add-temp", project_1.default.add_temp);
router.post("/add-bid", project_1.default.add_bid);
router.post("/update-bid", project_1.default.update_bid);
router.post("/send-msg", project_1.default.send_msg);
router.post("/send-bid-msg", project_1.default.send_bid_msg);
router.post("/update_release_payment", project_1.default.update_release_payment);
router.post("/machinist_confirmation_message", project_1.default.machinist_confirmation_message);
router.post("/shipping_message_send", project_1.default.shipping_message_send);
router.post("/request_release_funds", project_1.default.request_release_funds);
router.post("/update_read_my_msg", project_1.default.update_read_my_msgs);
router.post("/add-desccomment", project_1.default.add_desccomment);
router.get("/inbox-count", project_1.default.inbox_count);
router.post("/update_unread_my_msg", project_1.default.update_unread_my_msgs);
router.post("/update_remove_my_msg", project_1.default.update_remove_my_msgs);
router.get("/project_finalise_image", project_1.default.project_finalise_image);
router.get("/reviews", project_1.default.user_reviews);
router.get("/customer_review", project_1.default.customer_reviews);
router.get("/my-projects", project_1.default.my_project);
router.get("/review-proj", project_1.default.review_projects);
router.get("/image-list", project_1.default.image_list);
router.get("/notifs", project_1.default.notifs);
router.get("/project-review", project_1.default.project_review);
router.get("/all-lists", project_1.default.all_lists);
router.get("/project-gallery", project_1.default.project_gallery);
router.get("/page-details", project_1.default.page_details);
router.get("/public-profile-api", project_1.default.public_profile_api);
router.get("/public-me", project_1.default.public_me);
router.get("/public-profile-total-jobs", project_1.default.public_profile_total_jobs);
router.get("/public-user-reviews", project_1.default.public_user_reviews);
router.get("/offer-reviews-feedback", project_1.default.offer_reviews_feedback);
router.get("/get-additional-comment", project_1.default.get_additional_comment);
router.post("/save-invoice", project_1.default.save_invoice);
router.post("/delete-additional-file", project_1.default.delete_additional_file);
router.post("/delete-profile-picture", project_1.default.delete_profile_picture);
router.post("/delete-portfolio-picture", project_1.default.delete_portfolio_picture);
router.get("/project-detail-seo", project_1.default.project_detail_seo);
router.get("/public-profile-finalised-image", project_1.default.public_profile_finalised_image);
router.get("/notif-count", project_1.default.notif_count);
router.post("/mark-notif-read", project_1.default.mark_read_notification);
router.post("/send-mail-test", project_1.default.send_mail_test);
router.get("/footer-page-content", project_1.default.footer_page_content);
router.get("/page-content-details", project_1.default.page_content_details);
router.get("/faq-content", project_1.default.faq_content);
exports.default = router;
