"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var sequelize_1 = require("sequelize");
var db_1 = __importDefault(require("../config/db"));
var sequelize = new sequelize_1.Sequelize(db_1.default.db, db_1.default.user, db_1.default.password, {
    host: db_1.default.host,
    dialect: db_1.default.dialect,
    pool: {
        max: db_1.default.pool.max,
        min: db_1.default.pool.min,
        acquire: db_1.default.pool.acquire,
        idle: db_1.default.pool.idle,
    },
    logging: process.env.NODE_ENV === "production" ? false : false,
    dialectOptions: {
        dateStrings: true,
        typeCast: true,
        decimalNumbers: true,
    },
    define: {
        timestamps: false,
    },
    timezone: "+01:00",
    // logging: false
});
var db = {
    sequelize: sequelize,
    Sequelize: sequelize_1.Sequelize,
};
exports.default = db;
