"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var _crypto = require("crypto");
var env_1 = __importDefault(require("../config/env"));
var axios_1 = __importDefault(require("axios"));
/**
 * Generate password from allowed word
 */
var digits = "123456789";
var alphabets = "abcdefghijklmnopqrstuvwxyz";
var upperCase = alphabets.toUpperCase();
var specialChars = "#!&@";
var key = env_1.default.secret;
function rand(min, max) {
    var random = Math.random();
    return Math.floor(random * (max - min) + min);
}
exports.default = {
    /**
     * Generate OTP of the length
     * @param  {number} length length of password.
     * @param  {object} options
     * @param  {boolean} options.digits Default: `true` true value includes digits in OTP
     * @param  {boolean} options.alphabets Default: `false` true value includes alphabets in OTP
     * @param  {boolean} options.upperCase Default: `false` true value includes upperCase in OTP
     * @param  {boolean} options.specialChars Default: `false` true value includes specialChars in OTP
     */
    generate: function (length, options) {
        length = length || 10;
        var generateOptions = options || {};
        generateOptions.digits = Object.prototype.hasOwnProperty.call(generateOptions, "digits")
            ? options.digits
            : true;
        generateOptions.alphabets = Object.prototype.hasOwnProperty.call(generateOptions, "alphabets")
            ? options.alphabets
            : false;
        generateOptions.upperCase = Object.prototype.hasOwnProperty.call(generateOptions, "upperCase")
            ? options.upperCase
            : false;
        generateOptions.specialChars = Object.prototype.hasOwnProperty.call(generateOptions, "specialChars")
            ? options.specialChars
            : false;
        var allowsChars = ((generateOptions.digits || "") && digits) +
            ((generateOptions.alphabets || "") && alphabets) +
            ((generateOptions.upperCase || "") && upperCase) +
            ((generateOptions.specialChars || "") && specialChars);
        var password = "";
        while (password.length < length) {
            if (password.length == 1 && password == "0") {
                password = "1";
            }
            var charIndex = rand(0, allowsChars.length - 1);
            password += allowsChars[charIndex];
        }
        return password.toString();
    },
    hash: function (phone, otp, expiresAfter, algorithm) {
        if (expiresAfter === void 0) { expiresAfter = 3; }
        if (algorithm === void 0) { algorithm = "sha256"; }
        otp = otp.toString();
        var ttl = expiresAfter * 60 * 1000; //Expires after in Minutes, converteed to miliseconds
        var expires = Date.now() + ttl; //timestamp to 1 minutes in the future
        var data = "".concat(phone, ".").concat(otp, ".").concat(expires); // phone.otp.expiry_timestamp
        var hashBase = _crypto
            .createHmac(algorithm, key)
            .update(data)
            .digest("hex"); // creating SHA256 hash of the data
        // Hash.expires, format to send to the user
        // you have to implement the function to send SMS yourself. For demo purpose. let's assume it's called sendSMS
        return "".concat(hashBase, ".").concat(expires);
    },
    verify: function (phone, otp, hash, algorithm) {
        if (algorithm === void 0) { algorithm = "sha256"; }
        otp = otp.toString();
        if (!hash.match("."))
            return false; // Hash should have at least one dot
        // Separate Hash value and expires from the hash returned from the user(
        var _a = hash.split("."), hashValue = _a[0], expires = _a[1];
        // Check if expiry time has passed
        var now = Date.now();
        if (now > expires)
            return false;
        // Calculate new hash with the same key and the same algorithm
        var data = "".concat(phone, ".").concat(otp, ".").concat(expires);
        var newCalculatedHash = _crypto
            .createHmac(algorithm, key)
            .update(data)
            .digest("hex");
        // Match the hashes
        return newCalculatedHash === hashValue;
    },
    generateMail: function (name) {
        var splitName = name.split(" ");
        var firstName = splitName[0];
        var secondName = splitName[1];
        return "".concat(secondName).concat(firstName, "@gmail.com").toLowerCase();
    },
    sendSms: function (mobile, otp) { return __awaiter(void 0, void 0, void 0, function () {
        var params, url;
        return __generator(this, function (_a) {
            params = {};
            url = "";
            axios_1.default
                .get(url, { params: params })
                .then(function (response) { return console.log(response); })
                .catch(function (err) { return console.error(err); });
            return [2 /*return*/];
        });
    }); },
};
