"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var env_1 = __importDefault(require("../config/env"));
var ignorePaths = [
    "/user/auth/login",
    "/user/auth/test",
    "/user/auth/register",
    "/user/auth/forgot-username",
    "/user/auth/generate-new-password",
    "/user/auth/send-mobile-otp",
    "/user/auth/get-otp",
    "/user/auth/verify-mobile-otp",
    "/user/project/list",
    "/user/project/detail",
    "/user/project/add-temp",
    "/user/auth/google-login",
    "/user/auth/register",
    "/user/auth/forgot-password",
    "/public",
    "/send-test-notification",
    "/user/auth/verify-otp",
    "/user/auth/send-otp",
    "/user/project/get-my-temp",
    "/user/project/image-list",
    "/user/project/all-lists",
    "/user/project/project-gallery",
    "/user/project/all-reviews",
    "/user/project/review-proj",
    "/user/project/public-me",
    "/user/project/public-profile-total-jobs",
    "/user/project/public-profile-api",
    "/user/project/public-user-reviews",
    "/user/project/offer-reviews-feedback",
    "/user/project/project_finalise_image",
    "/user/project/get-additional-comment",
    "/user/project/page-details",
    "/user/project/project-detail-seo",
    "/user/project/public-profile-finalised-image",
    "/user/project/notif-count",
    "/user/project/mark-notif-read",
    "/user/project/send-mail-test",
    "/user/project/footer-page-content",
    "/user/project/page-content-details",
    "/user/project/faq-content",
    "/user/project/steps-text",
    "/user/project/get-spacer-projects",
    "/user/project/project-gallery-new",
];
function verifyUser(req, res, next) {
    return __awaiter(this, void 0, void 0, function () {
        var token, ignore, parts, scheme, credentials, user;
        return __generator(this, function (_a) {
            ignore = ignorePaths.indexOf(req.path) > -1;
            if (req.url.startsWith("/public")) {
                ignore = true;
            }
            if (req.method === "OPTIONS" &&
                req.headers.hasOwnProperty("access-control-request-headers")) {
                return [2 /*return*/, res.send("No DATA")];
                // const hasAuthInAccessControl = !!~req.headers[
                // 	"access-control-request-headers"
                // ]
                // 	.split(",")
                // 	.map(function (header) {
                // 		return header.trim();
                // 	})
                // 	.indexOf("authorization");
                // if (hasAuthInAccessControl) {
                // 	return next();
                // }
            }
            if (req.headers && req.headers.authorization) {
                parts = req.headers.authorization.split(" ");
                if (parts.length === 2) {
                    scheme = parts[0];
                    credentials = parts[1];
                    if (/^Bearer$/i.test(scheme)) {
                        token = credentials;
                        req.token = token;
                    }
                    else {
                        if (!ignore) {
                            return [2 /*return*/, res.json({
                                    status: false,
                                    message: "Invalid request.",
                                    data: null,
                                })];
                        }
                    }
                }
                else {
                    if (!ignore) {
                        return [2 /*return*/, res.json({
                                status: false,
                                message: "Invalid request.",
                                data: null,
                            })];
                    }
                }
            }
            if (!token && !ignore) {
                return [2 /*return*/, res.json({
                        status: false,
                        message: "No authorization token was found.",
                        data: null,
                    })];
            }
            if (token) {
                user = void 0;
                try {
                    user = jsonwebtoken_1.default.verify(token !== null && token !== void 0 ? token : "", env_1.default.secret);
                }
                catch (e) {
                    console.table(e);
                }
                if (!user && !ignore) {
                    return [2 /*return*/, res.status(401).json({
                            status: false,
                            message: "Invalid token.",
                            data: null,
                        })];
                }
                if (user === null || user === void 0 ? void 0 : user.id) {
                    try {
                        req.user = user;
                    }
                    catch (e) { }
                }
            }
            return [2 /*return*/, next()];
        });
    });
}
exports.default = verifyUser;
