"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.bids = void 0;
var sequelize_1 = require("sequelize");
var bids = /** @class */ (function (_super) {
    __extends(bids, _super);
    function bids() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    bids.initModel = function (sequelize) {
        return sequelize.define('bids', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                primaryKey: true
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            user_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            bid_days: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            bid_hours: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            bid_file: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            bid_amount: {
                type: sequelize_1.DataTypes.MEDIUMINT,
                allowNull: true
            },
            bid_amount_gbp: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            bid_time: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            bid_desc: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            lowbid_notify: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: true
            },
            escrow_flag: {
                type: sequelize_1.DataTypes.SMALLINT,
                allowNull: true
            },
            no_offer: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                comment: "1=offer, 2=Blank offer"
            }
        }, {
            tableName: 'bids',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
                {
                    name: "user_id",
                    using: "BTREE",
                    fields: [
                        { name: "user_id" },
                    ]
                },
            ]
        });
    };
    return bids;
}(sequelize_1.Model));
exports.bids = bids;
