"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.invoices = void 0;
var sequelize_1 = require("sequelize");
var invoices = /** @class */ (function (_super) {
    __extends(invoices, _super);
    function invoices() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    invoices.initModel = function (sequelize) {
        return sequelize.define('invoices', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                primaryKey: true
            },
            inv_no: {
                type: sequelize_1.DataTypes.BIGINT,
                allowNull: false
            },
            project_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            transaction_id: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'transactions',
                    key: 'id'
                }
            },
            commission_rate: {
                type: sequelize_1.DataTypes.DECIMAL(10, 2),
                allowNull: false
            },
            pdf_link: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            created_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: false
            }
        }, {
            tableName: 'invoices',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "transaction_id",
                    using: "BTREE",
                    fields: [
                        { name: "transaction_id" },
                    ]
                },
            ]
        });
    };
    return invoices;
}(sequelize_1.Model));
exports.invoices = invoices;
