"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.messages = void 0;
var sequelize_1 = require("sequelize");
var messages = /** @class */ (function (_super) {
    __extends(messages, _super);
    function messages() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    messages.initModel = function (sequelize) {
        return sequelize.define('messages', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            reply_for: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true
            },
            from_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            to_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            buyer_message_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            programmer_message_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            provider_delete_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            buyer_delete_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            message: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            created: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            notification_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true,
                defaultValue: "0",
                comment: "P=\"Prebid\",N=\"Notifications\""
            },
            deluserid: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            attach_file: {
                type: sequelize_1.DataTypes.STRING(150),
                allowNull: true
            },
            approve: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            machine_parts_image: {
                type: sequelize_1.DataTypes.STRING(1500),
                allowNull: true
            }
        }, {
            tableName: 'messages',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
                {
                    name: "from_id",
                    using: "BTREE",
                    fields: [
                        { name: "from_id" },
                    ]
                },
                {
                    name: "to_id",
                    using: "BTREE",
                    fields: [
                        { name: "to_id" },
                    ]
                },
            ]
        });
    };
    return messages;
}(sequelize_1.Model));
exports.messages = messages;
