"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.notif_email_list = void 0;
var sequelize_1 = require("sequelize");
var notif_email_list = /** @class */ (function (_super) {
    __extends(notif_email_list, _super);
    function notif_email_list() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    notif_email_list.initModel = function (sequelize) {
        return sequelize.define('notif_email_list', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                primaryKey: true
            },
            customer_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            supplier_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            email_type: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: false
            },
            email_subject: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            email_body: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            notif_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: false
            },
            message_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: false
            }
        }, {
            tableName: 'notif_email_list',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "customer_id",
                    using: "BTREE",
                    fields: [
                        { name: "customer_id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
            ]
        });
    };
    return notif_email_list;
}(sequelize_1.Model));
exports.notif_email_list = notif_email_list;
