"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.payments = void 0;
var sequelize_1 = require("sequelize");
var payments = /** @class */ (function (_super) {
    __extends(payments, _super);
    function payments() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    payments.initModel = function (sequelize) {
        return sequelize.define('payments', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.TINYINT.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            title: {
                type: sequelize_1.DataTypes.STRING(32),
                allowNull: false
            },
            deposit_description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            withdraw_description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            is_deposit_enabled: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: false,
                defaultValue: 1
            },
            is_withdraw_enabled: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: false,
                defaultValue: 1
            },
            deposit_minimum: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: false
            },
            withdraw_minimum: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: false
            },
            mail_id: {
                type: sequelize_1.DataTypes.STRING(128),
                allowNull: false
            },
            url: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            commission: {
                type: sequelize_1.DataTypes.FLOAT,
                allowNull: false
            },
            is_enable: {
                type: sequelize_1.DataTypes.BOOLEAN,
                allowNull: false
            },
            url_status: {
                type: sequelize_1.DataTypes.BOOLEAN,
                allowNull: false
            },
            language: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            }
        }, {
            tableName: 'payments',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
            ]
        });
    };
    return payments;
}(sequelize_1.Model));
exports.payments = payments;
