"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.project_images = void 0;
var sequelize_1 = require("sequelize");
var project_images = /** @class */ (function (_super) {
    __extends(project_images, _super);
    function project_images() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    project_images.initModel = function (sequelize) {
        return sequelize.define('project_images', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.BIGINT,
                allowNull: false,
                primaryKey: true
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            project_name: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            project_post_date: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: false
            },
            cust_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            sup_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            attach_file: {
                type: sequelize_1.DataTypes.STRING(150),
                allowNull: false
            },
            upload_date: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: false
            },
            approved: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                comment: "1= Unapproved, 2=Approved"
            },
            country_code: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            adminApprove: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            }
        }, {
            tableName: 'project_images',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
            ]
        });
    };
    return project_images;
}(sequelize_1.Model));
exports.project_images = project_images;
