"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.projects_preview = void 0;
var sequelize_1 = require("sequelize");
var projects_preview = /** @class */ (function (_super) {
    __extends(projects_preview, _super);
    function projects_preview() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    projects_preview.initModel = function (sequelize) {
        return sequelize.define('projects_preview', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            project_name: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            project_status: {
                type: sequelize_1.DataTypes.ENUM('0', '1', '2', '3'),
                allowNull: false
            },
            description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            project_categories: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            budget_min: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: true,
                defaultValue: 0
            },
            budget_max: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: true,
                defaultValue: 0
            },
            is_feature: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            is_urgent: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            is_hide_bids: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            is_private: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            creator_id: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: false
            },
            created: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            enddate: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            open_days: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            programmer_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            project_award_date: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            checkstamp: {
                type: sequelize_1.DataTypes.STRING(50),
                allowNull: false
            },
            buyer_rated: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: false
            },
            provider_rated: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: false
            },
            project_paid: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: false
            },
            CONTACT: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            SALARY: {
                type: sequelize_1.DataTypes.STRING(15),
                allowNull: false
            },
            FLAG: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            SALARYTYPE: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: false
            }
        }, {
            tableName: 'projects_preview',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
            ]
        });
    };
    return projects_preview;
}(sequelize_1.Model));
exports.projects_preview = projects_preview;
