"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.projects_temp = void 0;
var sequelize_1 = require("sequelize");
var projects_temp = /** @class */ (function (_super) {
    __extends(projects_temp, _super);
    function projects_temp() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    projects_temp.initModel = function (sequelize) {
        return sequelize.define('projects_temp', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            project_name: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            project_status: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: false,
                defaultValue: "0"
            },
            buyer_complete_status: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            provider_complete_status: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            expedition_day: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: true
            },
            expedition_day2: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: true
            },
            track_number: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            additional_description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            project_image: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            project_categories: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            project_start: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            visibility: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: false
            },
            start_bid: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            budget_min: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: true,
                defaultValue: 0
            },
            budget_max: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: true,
                defaultValue: 0
            },
            is_feature: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            is_urgent: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            is_hide_bids: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            creator_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true
            },
            created: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            enddate: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            programmer_id: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            bid_select_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            unpaid_project_notify_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            checkstamp: {
                type: sequelize_1.DataTypes.STRING(50),
                allowNull: true
            },
            buyer_rated: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: true
            },
            provider_rated: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: true
            },
            project_paid: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: true
            },
            project_award_date: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            project_award_date_format: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            project_fund_date_format: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            fund_release_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            notification_status: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                defaultValue: 0
            },
            attachment_url: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            image: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            first_upload: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            attachment_name: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            attachment_folder: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            is_private: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                defaultValue: 0
            },
            private_users: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            contact: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            salary: {
                type: sequelize_1.DataTypes.STRING(15),
                allowNull: true
            },
            flag: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                defaultValue: 1
            },
            salarytype: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            escrow_due: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            city: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            zipcode: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            post_for: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            project_post_format_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            project_post_date: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: true
            },
            project_expiry_date: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: true
            },
            expired_notification_sent: {
                type: sequelize_1.DataTypes.STRING(1),
                allowNull: false,
                defaultValue: "N"
            },
            fund_notification_sent: {
                type: sequelize_1.DataTypes.STRING(1),
                allowNull: false,
                defaultValue: "N"
            },
            unpaid_project_notif: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            site_fr: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                defaultValue: 0
            },
            site_uk: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                defaultValue: 0
            },
            site_it: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                defaultValue: 0
            },
            country_code: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            pro_job: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                defaultValue: 0
            },
            images: {
                type: sequelize_1.DataTypes.JSON,
                allowNull: true
            }
        }, {
            tableName: 'projects_temp',
            timestamps: true,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "creator_id",
                    using: "BTREE",
                    fields: [
                        { name: "creator_id" },
                    ]
                },
            ]
        });
    };
    return projects_temp;
}(sequelize_1.Model));
exports.projects_temp = projects_temp;
