"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.reviews = void 0;
var sequelize_1 = require("sequelize");
var reviews = /** @class */ (function (_super) {
    __extends(reviews, _super);
    function reviews() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    reviews.initModel = function (sequelize) {
        return sequelize.define('reviews', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                primaryKey: true
            },
            comments: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            rating: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate1: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate2: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate3: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate4: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate5: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rate6: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            provider_rating_avg: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate1: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate2: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate3: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate4: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate5: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rate6: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            emp_rating_avg: {
                type: sequelize_1.DataTypes.FLOAT(2, 1),
                allowNull: true
            },
            review_time: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            review_post_date: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            review_type: {
                type: sequelize_1.DataTypes.ENUM('1', '2'),
                allowNull: true
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            buyer_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            provider_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            hold: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: true
            },
            buyer_status: {
                type: sequelize_1.DataTypes.STRING(20),
                allowNull: true
            },
            provider_status: {
                type: sequelize_1.DataTypes.STRING(20),
                allowNull: true
            },
            country_code: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            }
        }, {
            tableName: 'reviews',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "buyer_id",
                    using: "BTREE",
                    fields: [
                        { name: "buyer_id" },
                    ]
                },
                {
                    name: "provider_id",
                    using: "BTREE",
                    fields: [
                        { name: "provider_id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
            ]
        });
    };
    return reviews;
}(sequelize_1.Model));
exports.reviews = reviews;
