"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.transactions = void 0;
var sequelize_1 = require("sequelize");
var transactions = /** @class */ (function (_super) {
    __extends(transactions, _super);
    function transactions() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    transactions.initModel = function (sequelize) {
        return sequelize.define('transactions', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            type: {
                type: sequelize_1.DataTypes.STRING(64),
                allowNull: false
            },
            creator_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                defaultValue: 0,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            buyer_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                defaultValue: 0
            },
            provider_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                defaultValue: 0
            },
            transaction_time: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false
            },
            amount: {
                type: sequelize_1.DataTypes.FLOAT,
                allowNull: false
            },
            amount_gbp: {
                type: sequelize_1.DataTypes.FLOAT,
                allowNull: false
            },
            status: {
                type: sequelize_1.DataTypes.CHAR(16),
                allowNull: true
            },
            description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: false
            },
            paypal_address: {
                type: sequelize_1.DataTypes.STRING(256),
                allowNull: true
            },
            user_type: {
                type: sequelize_1.DataTypes.STRING(256),
                allowNull: true
            },
            reciever_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'users',
                    key: 'id'
                }
            },
            project_id: {
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: true,
                references: {
                    model: 'projects',
                    key: 'id'
                }
            },
            package_id: {
                type: sequelize_1.DataTypes.SMALLINT,
                allowNull: true
            },
            update_flag: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: true
            },
            country_code: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            }
        }, {
            tableName: 'transactions',
            timestamps: false,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "project_id",
                    using: "BTREE",
                    fields: [
                        { name: "project_id" },
                    ]
                },
                {
                    name: "creator_id",
                    using: "BTREE",
                    fields: [
                        { name: "creator_id" },
                    ]
                },
                {
                    name: "reciever_id",
                    using: "BTREE",
                    fields: [
                        { name: "reciever_id" },
                    ]
                },
            ]
        });
    };
    return transactions;
}(sequelize_1.Model));
exports.transactions = transactions;
