"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.users = void 0;
var sequelize_1 = require("sequelize");
var users = /** @class */ (function (_super) {
    __extends(users, _super);
    function users() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    users.initModel = function (sequelize) {
        return sequelize.define('users', {
            id: {
                autoIncrement: true,
                type: sequelize_1.DataTypes.BIGINT.UNSIGNED,
                allowNull: false,
                primaryKey: true
            },
            refid: {
                type: sequelize_1.DataTypes.STRING(128),
                allowNull: false,
                defaultValue: "0"
            },
            country_code: {
                type: sequelize_1.DataTypes.INTEGER.UNSIGNED,
                allowNull: false,
                references: {
                    model: 'country',
                    key: 'id'
                }
            },
            user_name: {
                type: sequelize_1.DataTypes.STRING(128),
                allowNull: true
            },
            name: {
                type: sequelize_1.DataTypes.STRING(128),
                allowNull: false
            },
            surname: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: false
            },
            address1: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            address2: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            description: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            company_name: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            company_number: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            role_id: {
                type: sequelize_1.DataTypes.SMALLINT,
                allowNull: false
            },
            password: {
                type: sequelize_1.DataTypes.STRING(500),
                allowNull: true
            },
            email: {
                type: sequelize_1.DataTypes.STRING(128),
                allowNull: false
            },
            paypal_email: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            profile_desc: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            service_desc: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            voter: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            prof_pic: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            prot_pic: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            pdf_file: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            account: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            user_status: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: false,
                defaultValue: 0
            },
            activation_key: {
                type: sequelize_1.DataTypes.STRING(32),
                allowNull: true
            },
            zcode: {
                type: sequelize_1.DataTypes.CHAR(100),
                allowNull: true
            },
            Squestion: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            answer: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            state: {
                type: sequelize_1.DataTypes.STRING(64),
                allowNull: true
            },
            city: {
                type: sequelize_1.DataTypes.STRING(64),
                allowNull: true
            },
            country_symbol: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            project_notify: {
                type: sequelize_1.DataTypes.CHAR(10),
                allowNull: true
            },
            bid_notify: {
                type: sequelize_1.DataTypes.CHAR(10),
                allowNull: true
            },
            message_notify: {
                type: sequelize_1.DataTypes.CHAR(10),
                allowNull: true
            },
            rate: {
                type: sequelize_1.DataTypes.SMALLINT,
                allowNull: true
            },
            logo: {
                type: sequelize_1.DataTypes.STRING(64),
                allowNull: true
            },
            created: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            last_activity: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            user_rating: {
                type: sequelize_1.DataTypes.SMALLINT,
                allowNull: true
            },
            num_reviews: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            rating_hold: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            tot_rating: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            suspend_status: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: false,
                defaultValue: "0"
            },
            ban_status: {
                type: sequelize_1.DataTypes.ENUM('0', '1'),
                allowNull: false,
                defaultValue: "0"
            },
            admin_status: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            admin_status_uk: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            admin_status_it: {
                type: sequelize_1.DataTypes.CHAR(1),
                allowNull: true
            },
            job_fr: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            job_uk: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            job_it: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            choice: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true
            },
            supLogin: {
                type: sequelize_1.DataTypes.TEXT,
                allowNull: true
            },
            lang: {
                type: sequelize_1.DataTypes.STRING(11),
                allowNull: true
            },
            pro_user: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                defaultValue: 0
            },
            pro_vat: {
                type: sequelize_1.DataTypes.FLOAT,
                allowNull: true
            },
            siren: {
                type: sequelize_1.DataTypes.STRING(255),
                allowNull: true
            },
            mailchimp_id: {
                type: sequelize_1.DataTypes.STRING(100),
                allowNull: true
            },
            nxtduedate: {
                type: sequelize_1.DataTypes.DATEONLY,
                allowNull: true
            },
            entrepreneur: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: true,
                comment: "0=>Not Entrepreneur and 1 => Entrepreneur"
            },
            bid_status: {
                type: sequelize_1.DataTypes.INTEGER,
                allowNull: false,
                defaultValue: 1,
                comment: "0=>Not able to bid and 1 => able to bid"
            },
            last_seen: {
                type: sequelize_1.DataTypes.DATE,
                allowNull: true
            },
            show_modal: {
                type: sequelize_1.DataTypes.TINYINT,
                allowNull: true
            }
        }, {
            tableName: 'users',
            timestamps: true,
            indexes: [
                {
                    name: "PRIMARY",
                    unique: true,
                    using: "BTREE",
                    fields: [
                        { name: "id" },
                    ]
                },
                {
                    name: "country_code",
                    using: "BTREE",
                    fields: [
                        { name: "country_code" },
                    ]
                },
            ]
        });
    };
    return users;
}(sequelize_1.Model));
exports.users = users;
