"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var joi_1 = __importDefault(require("joi"));
exports.default = {
    addProject: {
        project_name: joi_1.default.string().required(),
        description: joi_1.default.string().required(),
        visibility: joi_1.default.string().required(),
        post_for: joi_1.default.number().required(),
    },
    question: {
        project_id: joi_1.default.string().required(),
        message: joi_1.default.string().required(),
    },
    answer: {
        id: joi_1.default.string().required(),
        message: joi_1.default.string().required(),
    },
    get_temp: {
        project_ids: joi_1.default.array().min(1).required(),
    },
    get_my_temp: {
        project_id: joi_1.default.string().required(),
    },
    addBid: {
        bid_desc: joi_1.default.string().required(),
        bid_amount: joi_1.default.number().allow("").required(),
        bid_amount_gbp: joi_1.default.number().allow("").required(),
        bid_days: joi_1.default.number().required(),
        project_id: joi_1.default.number().required(),
        user_id: joi_1.default.number().required(),
    },
    updateBid: {
        bid_desc: joi_1.default.string().required(),
        bid_amount: joi_1.default.number().allow("").required(),
        bid_amount_gbp: joi_1.default.number().allow("").required(),
        bid_days: joi_1.default.number().required(),
        project_id: joi_1.default.number().required(),
        user_id: joi_1.default.number().required(),
    },
    send_msg: {
        project_id: joi_1.default.number().required(),
        to_id: joi_1.default.number().required(),
        message: joi_1.default.string().required(),
    },
    send_bid_msg: {
        project_id: joi_1.default.number().required(),
        send_to: joi_1.default.number().required(),
        msg_box: joi_1.default.string().required(),
    },
    list_msgs: {
        project_id: joi_1.default.number().required(),
        to_id: joi_1.default.number().required(),
        from_id: joi_1.default.number().required(),
    },
    list_bid_msgs: {
        project_id: joi_1.default.number().required(),
        to_id: joi_1.default.number().required(),
        from_id: joi_1.default.number().required(),
    },
    select_machinist: {
        programmer_id: joi_1.default.string().required(),
        project_id: joi_1.default.string().required(),
        bid_id: joi_1.default.string().required(),
    },
    add_payment: {
        project_id: joi_1.default.string().required(),
        amount: joi_1.default.number().required(),
    },
    update_balance: {
        project_id: joi_1.default.string().required(),
        amount: joi_1.default.number().required(),
    },
    review_machinist: {
        project_id: joi_1.default.string().required(),
        comments: joi_1.default.string().required(),
        provider_rate1: joi_1.default.number().required(),
        provider_rate2: joi_1.default.number().required(),
        provider_rate3: joi_1.default.number().required(),
        provider_rate4: joi_1.default.number().required(),
    },
    send_confirm: {
        project_id: joi_1.default.number().required(),
        to_id: joi_1.default.number().required(),
        message: joi_1.default.string().required(),
        date: joi_1.default.date().required(),
        from_id: joi_1.default.number().required(),
    },
    send_shipping: {
        project_id: joi_1.default.number().required(),
        to_id: joi_1.default.number().required(),
        message: joi_1.default.string().required(),
        date: joi_1.default.date().required(),
        from_id: joi_1.default.number().required(),
        tracking_no: joi_1.default.string().required(),
    },
    addComment: {
        project_id: joi_1.default.string().required(),
        description: joi_1.default.string().required(),
    },
};
