"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var joi_1 = __importDefault(require("joi"));
exports.default = {
    editUser: {
        name: joi_1.default.string().required(),
        surname: joi_1.default.string().required(),
        user_name: joi_1.default.string().required(),
        zcode: joi_1.default.required(),
        city: joi_1.default.required(),
        country_code: joi_1.default.number().required(),
        address1: joi_1.default.required(),
        description: joi_1.default.required(),
        service_desc: joi_1.default.required(),
        tva: joi_1.default.required(),
        company_name: joi_1.default.required(),
        company_number: joi_1.default.required(),
        siren: joi_1.default.required(),
        prof_pic: joi_1.default.required(),
        prot_pic: joi_1.default.required(),
        country_symbol: joi_1.default.required(),
    },
    editAddress: {
        name: joi_1.default.string().required(),
        zcode: joi_1.default.string().required(),
        city: joi_1.default.string().required(),
        address1: joi_1.default.string().required(),
    },
    change_password: {
        old_password: joi_1.default.string().required(),
        new_password: joi_1.default.string()
            .pattern(new RegExp("^(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])(?=.{6,})"))
            .required()
            .messages({
            "string.pattern.base": "New Password must contains at least 6 characters, including UPPER or lowercase with numbers.",
        }),
    },
};
