"use strict";
// // 👇️ ts-nocheck ignores all ts errors in the file
// // eslint-disable-next-line @typescript-eslint/ban-ts-comment
// // @ts-nocheck
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Validate = exports.Pick = void 0;
var response_helpers_1 = require("../../helpers/response-helpers");
var joi_1 = __importDefault(require("joi"));
var Pick = function (keys, object) {
    if (keys.length === 0) {
        return object;
    }
    var subset = Object.fromEntries(keys
        .filter(function (key) { return key in object; }) // line can be removed to make it inclusive
        .map(function (key) { return [key, object[key]]; }));
    return subset;
};
exports.Pick = Pick;
var Validate = function (res, keys, obj, body, _a) {
    var _b = _a.unknown, unknown = _b === void 0 ? false : _b;
    var pick = (0, exports.Pick)(keys, obj);
    var schema = joi_1.default.object(pick).unknown(unknown).validate(body);
    if (schema.error) {
        return (0, response_helpers_1.R)(res, false, schema.error.message);
    }
    var data = schema.value;
    return data;
};
exports.Validate = Validate;
